function [ P V ] = gen_2OCP( p_ref, v_ref,a_lim,phaseVar, q1, q2, p1,v1, p2,v2 )
[PF VF]=gen_OCP(p_ref, v_ref, a_lim, phaseVar, q1, q2, p1,v1);
[PB VB]=gen_OCP(fliplr(p_ref), diff(fliplr(p_ref)), a_lim, phaseVar, q1, q2, p2,-v2);

PB=fliplr(PB);
VB=-fliplr(VB);

[mP mIP]=min(abs(PF-PB));
[mF mIF]=min(abs(VF-VB));


P=[PF(1:mIP) PB(mIP+1:end)];
V=[VF(1:mIF) VB(mIF+1:end)];

end

function [ P1,V1 ] = gen_OCP( p_ref, v_ref,a_lim,phaseVar, q1, q2, p1,v1)
P1=p1;
V1=v1;

K=[q1 sqrt(q2^2+2*q1)];

for i =phaseVar;
    a = -K(1)*(p1-p_ref(i)) -K(2)*(v1-v_ref(i));
    if abs(a)>a_lim
        a = sign(a)*a_lim;
    end;
    v1 = v1 + a;
    p1 = p1 + v1;
    V1=[V1 v1];
    P1=[P1 p1];
    
    if i==phaseVar(end)
        a = -K(1)*(p1-p_ref(i)) -K(2)*(v1-v_ref(i));
        if abs(a)>a_lim
            a = sign(a)*a_lim;
        end;
        v1 = v1 + a;
        p1 = p1 + v1;
        P1=[P1 p1];
        
        %if i==round(length(v_ref)/2)
        %    p1=p1+0.5; %perturbation
        %end;
    end
end
end